import gnu.io.SerialPortEvent;
import gnu.io.SerialPortEventListener;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.Arrays;
import java.util.EventListener;

/**
 * 
 */

/**
 * @author Christophe HAVARD
 *
 */
public class FakeGlove implements IGlove {
	
	/**
	 * If set to true it means that a glove is connected.
	 */
	public boolean connected = false;
	private ICommands commands = new VibrationCommand();


	public FakeGlove(ByteArrayInputStream inputStream,ByteArrayOutputStream outputStream) {
		this.connected = true;
	}

	@Override
	public void read() {
		
	}

	@Override
	public void write(byte[] b) throws IOException{
		
		System.out.println("Sended value : " + Arrays.toString(b));
	}

	@Override
	public EventListener getInputEventListener() {
		return new SerialPortEventListener() {
			
			@Override
			public void serialEvent(SerialPortEvent arg0) {
				// TODO Auto-generated method stub
				
			}
		};
	}

	public void vibrate(FINGERS finger, int duration){
		byte[] trame = null;
		if(isConnected()){
			switch(finger){
			case THUMB:
				trame = commands.getThumb(duration);
				break;
			case FOREFINGER:
				trame = commands.getForeFinger(duration);
				break;
			case MIDDLEFINGER:
				trame = commands .getMiddleFinger(duration);
				break;
			case RINGFINGER:
				trame = commands.getRingFinger(duration);
				break;
			case LITTLEFINGER:
				trame = commands.getLittleFinger(duration);
				break;
			case ALL:
				trame = commands.getAllFingers(duration);
				break;
			}
			
			try {
				this.write(trame);
			} catch (IOException e) {
				System.err.println("Probleme avec l'envoi de la trame sur le serial port : " + e);
			}
		}
	}

	@Override
	public boolean isConnected() {
		return this.connected;
	}
	@Override
	public void setConnected(boolean b) {
		this.connected = b;
	}

	@Override
	public void vibrate(FINGERS finger, int duration, int vibrationLevel) {
		// TODO Auto-generated method stub
		
	}


}
