import java.io.IOException;
import java.util.EventListener;


/**
 * 
 */

/**
 * @author Christophe HAVARD
 *
 */
public interface IGlove {
	public void read() throws IOException;
	public void write(byte[] b) throws IOException;
	public EventListener getInputEventListener();
	/**
	 * Make the specified finger vibrate during the given duration.
	 * 
	 * @param The finger you want to vibrate. This finger is an enum type of the FINGERS class.
	 * @param The duration of the vibration, given in millisecond.
	 * 
	*/
	public void vibrate(FINGERS finger, int duration);
	public void vibrate(FINGERS finger, int duration, int vibrationLevel);
	
	public boolean isConnected();
	public void setConnected(boolean b);

}
