/**
 * 
 */

/**
 * @author Christophe HAVARD
 * Here we consider a 6 bytes long input.
 * The first fives characters represent the level of the vibration for each motor.
 * The last character is the vibration duration.
 *
 */
public class SimpleCommand implements ICommands {


	@Override
	public byte[] getLittleFinger(int duration) {
		byte realDuration = this.convertDuration(duration);
		byte[] trame = {
			(byte)'F',
			(byte)'0', 
			(byte)'0', 
			(byte)'0',
			(byte)'0',
			(byte)realDuration
		};
		
		return trame;
	}
	@Override
	public byte[] getLittleFinger(int duration, int level) {
		byte realDuration = this.convertDuration(duration);
		byte realLevel = this.convertLevel(level);
		byte[] trame = {
			(byte)realLevel,
			(byte)'0', 
			(byte)'0', 
			(byte)'0',
			(byte)'0',
			(byte)realDuration
		};
		
		return trame;
	}

	/* (non-Javadoc)
	 * @see ICommands#getForeFinger(int)
	 */
	@Override
	public byte[] getForeFinger(int duration) {
		byte realDuration = this.convertDuration(duration);
		byte[] trame = {
			(byte)'0',
			(byte)'0', 
			(byte)'0', 
			(byte)'F',
			(byte)'0',
			(byte)realDuration
		};
		
		return trame;
	}
	@Override
	public byte[] getForeFinger(int duration, int level) {
		byte realDuration = this.convertDuration(duration);
		byte realLevel = this.convertLevel(level);
		byte[] trame = {
			(byte)'0',
			(byte)'0', 
			(byte)'0', 
			(byte)realLevel,
			(byte)'0',
			(byte)realDuration
		};
		
		return trame;
	}

	/* (non-Javadoc)
	 * @see ICommands#getMiddleFinger(int)
	 */
	@Override
	public byte[] getMiddleFinger(int duration) {
		byte realDuration = this.convertDuration(duration);
		byte[] trame = {
			(byte)'0',
			(byte)'0', 
			(byte)'F', 
			(byte)'0',
			(byte)'0',
			(byte)realDuration
		};
		
		return trame;
	}
	
	@Override
	public byte[] getMiddleFinger(int duration, int level) {
		byte realDuration = this.convertDuration(duration);
		byte realLevel = this.convertLevel(level);
		byte[] trame = {
				(byte)'0',
				(byte)'0', 
				(byte)realLevel, 
				(byte)'0',
				(byte)'0',
				(byte)realDuration
		};
		
		return trame;
	}


	/* (non-Javadoc)
	 * @see ICommands#getRingFinger(int)
	 */
	@Override
	public byte[] getRingFinger(int duration) {
		byte realDuration = this.convertDuration(duration);
		byte[] trame = {
			(byte)'0',
			(byte)'F', 
			(byte)'0', 
			(byte)'0',
			(byte)'0',
			(byte)realDuration
		};
		
		return trame;
	}
	@Override
	public byte[] getRingFinger(int duration, int level) {
		byte realDuration = this.convertDuration(duration);
		byte realLevel = this.convertLevel(level);
		byte[] trame = {
			(byte)'0',
			(byte)realLevel, 
			(byte)'0', 
			(byte)'0',
			(byte)'0',
			(byte)realDuration
		};
		
		return trame;
	}


	/* (non-Javadoc)
	 * @see ICommands#getThumb(int)
	 */
	@Override
	public byte[] getThumb(int duration) {
		byte realDuration = this.convertDuration(duration);
		byte[] trame = {
			(byte)'0',
			(byte)'0', 
			(byte)'0', 
			(byte)'0',
			(byte)'F',
			(byte)realDuration
		};
		
		return trame;
	}
	
	@Override
	public byte[] getThumb(int duration, int level) {
		byte realDuration = this.convertDuration(duration);
		byte realLevel = this.convertLevel(level);
		byte[] trame = {
			(byte)'0',
			(byte)'0', 
			(byte)'0', 
			(byte)'0',
			(byte)realLevel,
			(byte)realDuration
		};
		
		return trame;
	}

	/* (non-Javadoc)
	 * @see ICommands#getAllFingers(int)
	 */
	@Override
	public byte[] getAllFingers(int duration) {
		byte realDuration = this.convertDuration(duration);
		byte[] trame = {
			(byte)'F',
			(byte)'F', 
			(byte)'F', 
			(byte)'F',
			(byte)'F',
			(byte)realDuration
		};
		
		return trame;
	}
	@Override
	public byte[] getAllFingers(int duration, int level) {
		byte realDuration = this.convertDuration(duration);
		byte realLevel = this.convertLevel(level);
		byte[] trame = {
			(byte)realLevel,
			(byte)realLevel, 
			(byte)realLevel, 
			(byte)realLevel,
			(byte)realLevel,
			(byte)realDuration
		};
		
		return trame;
	}






	
	// the duration is given in millisecond
	private byte convertDuration(int dur) {
		int i = (int) Math.ceil(dur / 10);
		i /= 16;
		i %= 15;
		byte b = 0;
		if (i >= 0 && i <= 9){
			b = (byte) (i + 48);
		} else if(i >=10 && i<= 15) {
			b = (byte) (i + 65);
		}
		System.out.println(b);
		System.out.println(Byte.valueOf(b));
		return b;
	}
	
	private byte convertLevel(final int level) {
		int i = level % 15;
		byte b = 0;
		if (i >= 0 && i <= 9){
			b = (byte) (i + 48);
		} else if(i >=10 && i<= 15) {
			b = (byte) (i + 65);
		}
		
		return b;
	}




}
