
/**
 * @author Christophe HAVARD
 *
 */
public class VibrationCommand implements ICommands {
	
	/**
	 * Here you can set the vibration duration you want to deliver. The value is in millisecond.
	 */
	public static int DURATION = 1000;
	
	/**
	 * This field is set in the Arduino program. Usually its value is 10.
	 */
	private static int coeffArduino = 10;
	public static byte test = (byte) (DURATION / (16 * coeffArduino));

	
	public byte[] getLittleFinger(int duration) {
		byte realDuration = this.convertDuration(duration);
		byte[] trame = {
			(byte)'F', (byte)'0', (byte)realDuration, 
			(byte)'0', (byte)'0', (byte)'0', 
			(byte)'0', (byte)'0', (byte)'0', 
			(byte)'0', (byte)'0', (byte)'0', 
			(byte)'0', (byte)'0', (byte)'0'
		};
		
		return trame;
	}
	

	public byte[] getForeFinger(int duration) {
		byte realDuration = this.convertDuration(duration);
		byte[] trame = {
			(byte)'0', (byte)'0', (byte)'0', 
			(byte)'0', (byte)'0', (byte)'0', 
			(byte)'0', (byte)'0', (byte)'0', 
			(byte)'F', (byte)'0', (byte)realDuration,
			(byte)'0', (byte)'0', (byte)'0'
		};
		
		return trame;
	}
	public byte[] getMiddleFinger(int duration) {
		byte realDuration = this.convertDuration(duration);
		byte[] trame = {
			(byte)'0', (byte)'0', (byte)'0', 
			(byte)'0', (byte)'0', (byte)'0', 
			(byte)'F', (byte)'0', (byte)realDuration,
			(byte)'0', (byte)'0', (byte)'0', 
			(byte)'0', (byte)'0', (byte)'0'
		};
		
		return trame;
	}	public byte[] getRingFinger(int duration) {
		byte realDuration = this.convertDuration(duration);
		byte[] trame = {
			(byte)'0', (byte)'0', (byte)'0', 
			(byte)'F', (byte)'0', (byte)realDuration,
			(byte)'0', (byte)'0', (byte)'0', 
			(byte)'0', (byte)'0', (byte)'0', 
			(byte)'0', (byte)'0', (byte)'0'
		};
		
		return trame;
	}	public byte[] getThumb(int duration) {
		byte realDuration = this.convertDuration(duration);
		byte[] trame = {
			(byte)'0', (byte)'0', (byte)'0', 
			(byte)'0', (byte)'0', (byte)'0', 
			(byte)'0', (byte)'0', (byte)'0', 
			(byte)'0', (byte)'0', (byte)'0',
			(byte)'F', (byte)'0', (byte)realDuration
		};
		
		return trame;
	}	public byte[] getAllFingers(int duration) {
		byte realDuration = this.convertDuration(duration);
		byte[] trame = {
			(byte)'F', (byte)'0', (byte)realDuration,
			(byte)'F', (byte)'0', (byte)realDuration,
			(byte)'F', (byte)'0', (byte)realDuration,
			(byte)'F', (byte)'0', (byte)realDuration,
			(byte)'F', (byte)'0', (byte)realDuration
		};
		
		return trame;
	}
		

	
	public static byte getTest(){
		return test;
	}
	private byte convertDuration(int duration2) {
		// TODO Auto-generated method stub
		return 57;
	}


	@Override
	public byte[] getThumb(int duration, int level) {
		// TODO Auto-generated method stub
		return null;
	}


	@Override
	public byte[] getForeFinger(int duration, int level) {
		// TODO Auto-generated method stub
		return null;
	}


	@Override
	public byte[] getMiddleFinger(int duration, int level) {
		// TODO Auto-generated method stub
		return null;
	}


	@Override
	public byte[] getRingFinger(int duration, int level) {
		// TODO Auto-generated method stub
		return null;
	}


	@Override
	public byte[] getLittleFinger(int duration, int level) {
		// TODO Auto-generated method stub
		return null;
	}


	@Override
	public byte[] getAllFingers(int duration, int level) {
		// TODO Auto-generated method stub
		return null;
	}
}
